For AI agents: a documentation index is available at the root level at /llms.txt and /llms-full.txt. Append /llms.txt to any URL for a page-level index, or .md for the markdown version of any page.
SupportDeel Home
OverviewPlatformEmployer of RecordContractorsGlobal PayrollHREmbeddedDeel ITAPI ReferenceChangelog
OverviewPlatformEmployer of RecordContractorsGlobal PayrollHREmbeddedDeel ITAPI ReferenceChangelog
  • Resources
    • Blog
    • Community
    • API spec
  • Global Payroll
    • Introduction
    • Time Tracking
    • Adjustments
  • Common Use Cases
    • Reimburse expenses
  • Endpoints
      • POSTCreate a New Shift Rate
      • DELDelete a Shift Rate by external ID
      • POSTGenerate timesheet upload url
      • GETRetrieve a Paginated List of Shift Rates
      • GETRetrieve a Shift Rate by External ID
      • GETRetrieve a timesheet
      • POSTReview a submitted timesheet
      • PATCHUpdate a shift rate
LogoLogo
SupportDeel Home
EndpointsTime Tracking

Generate timesheet upload url

POST
/time-tracking/timesheets/upload-url
POST
/rest/v2/time-tracking/timesheets/upload-url
$curl -X POST https://api.letsdeel.com/rest/v2/time-tracking/timesheets/upload-url \
> -H "Authorization: Bearer <token>" \
> -H "Content-Type: application/json" \
> -d '{
> "data": {
> "end_date": "2025-06-30",
> "file_name": "june_timesheets.csv",
> "start_date": "2025-06-01",
> "contract_id": "JvUc0hPV"
> }
>}'
1{
2 "data": {
3 "id": "880e8400-e29b-41d4-a716-446655440003",
4 "created_at": "2025-11-07T18:00:00.000Z",
5 "updated_at": "2025-11-07T18:00:00.000Z",
6 "upload_url": "https://my-unique-upload-bucket.s3.amazonaws.com/uploads/document.pdf?X-Amz-Algorithm=AWS4-HMAC-SHA256&X-Amz-Credential=AKIAIOSFODNN7EXAMPLE%2F20251107%2Fus-east-1%2Fs3%2Faws4_request&X-Amz-Date=20251107T180000Z&X-Amz-Expires=3600&X-Amz-SignedHeaders=host&X-Amz-Signature=a1b2c3d4e5f67890a1b2c3d4e5f67890a1b2c3d4e5f67890a1b2c3d4e5f67890",
7 "upload_fields": {
8 "key": "uploads/document.pdf",
9 "bucket": "my-unique-upload-bucket",
10 "Content-Type": "text/csv"
11 }
12 }
13}

Accepts timesheet file metadata and returns a pre-signed upload_url together with a new timesheet record id. Currently limited to EOR contracts. Token scopes: time-tracking:write

Was this page helpful?
Previous

Retrieve a Paginated List of Shift Rates

Next
Built with

Authentication

AuthorizationBearer
## Authentication The Deel API uses bearer tokens to authenticate requests. All API calls must be made over HTTPS — calls over plain HTTP or without authentication will fail. ```curl curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \ -H 'Authorization: Bearer YOUR-TOKEN-HERE' ``` [Learn more about authentication](/api/authentication)
OR
AuthorizationBearer

Standard OAuth2 security scheme based on https://swagger.io/docs/specification/authentication/

Request

timesheet information needed for uploading timesheet file
dataobjectRequired

Response

Timesheet created successfully. Returns upload URL, upload form fields, and timesheet ID.
dataobject

Errors

400
Bad Request Error
401
Unauthorized Error
403
Forbidden Error
404
Not Found Error
422
Unprocessable Entity Error
500
Internal Server Error

Authentication

The Deel API uses bearer tokens to authenticate requests. All API calls must be made over HTTPS — calls over plain HTTP or without authentication will fail.

1curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
2 -H 'Authorization: Bearer YOUR-TOKEN-HERE'

Learn more about authentication